import express, { Request, Response } from 'express';
import nodemailer from 'nodemailer';
import cors from 'cors';
import bodyParser from 'body-parser'

const app = express();
const port = 8080;

app.use(cors());
app.use(bodyParser.json())
app.use(express.json());

// Email sending endpoint
app.post('/send-email', async (req: Request, res: Response) => {
  const { name, email, message } = req.body;

  if (!name || !email || !message) {
    return res.status(400).send('All fields are required.');
  }

  // Create a Nodemailer transporter object using SMTP transport
  const transporter = nodemailer.createTransport({
    host: 'mail.getabyte.co.za', 
    port: 465, 
    secure: true, // True for 465, false for other ports
    auth: {
      user: 'website@getabyte.co.za', 
      pass: 'h&RXMP=I{(LJ'    
    }
  });

  // Email options
  const mailOptions = {
    from: 'website@getabyte.co.za',
    to: 'website@getabyte.co.za', // The recipient's email address
    subject: 'Website Comms',
    text: `Name: ${name}\nEmail: ${email}\nMessage: ${message}`
  };

  try {
    await transporter.sendMail(mailOptions);
    res.status(200).send('Email sent successfully.');
  } catch (error) {
    console.error('Error sending email:', error);
    res.status(500).send('Failed to send email. sfd' + error);
  }
});

// Start the server
app.listen(port, () => {
  console.log(`Server running at http://localhost:${port}`);
});
